#include "LogServerC.h"
#include "LogServer.hpp"
#include <orbsvcs/orbsvcs/CosNamingC.h>
#include <iostream>
#include <sstream>

using namespace CORBA;

int main (int argc, char **argv) {
    // create CORBA-ORB
    ORB_var orb = ORB_init(argc,argv);

    Object_var obj = orb->resolve_initial_references("NameService");
    CosNaming::NamingContext_var inc;
    inc = CosNaming::NamingContext::_narrow(obj.in());

    CosNaming::Name n_comp;
    n_comp.length(1);
    n_comp[0].id = "LogServer";
    n_comp[0].kind = "SimpleLogger";
    obj = inc->resolve(n_comp);
    ::Example::LogServer_var logger = ::Example::LogServer::_narrow(obj.in());
    ostringstream x(ostringstream::out);
    for (int i = 0;i < 10000; i++) {
        if ( i % 100 == 0) {
            x.str("");
            x << "channel" << i;
        }
        ostringstream y(ostringstream::out);
        y << "Message No. " << i;
        logger->log(x.str().c_str(), y.str().c_str());
        y.flush();
    }
    return 0;
}
