#include "LogServerS.h"
#include "LogServer.hpp"
#include <orbsvcs/orbsvcs/CosNamingC.h>

using namespace CORBA;

int main (int argc, char **argv) {
    // create CORBA-ORB
    ORB_var orb = ORB_init(argc,argv);

    // retrieve root-poa
    Object_ptr obj = orb->resolve_initial_references("RootPOA");
    PortableServer::POA_var poa = PortableServer::POA::_narrow(obj);

    // activate poa-manager
    PortableServer::POAManager_var mgr = poa->the_POAManager();
    mgr->activate();

    // create servant
    LogServer *logServer = new LogServer();
    POA_Example::LogServer_tie<LogServer> corba_logger(logServer);
    ::Example::LogServer_var servant = corba_logger._this();

    // retrieve NameService
    CosNaming::NamingContext_var inc;
    obj = orb->resolve_initial_references("NameService");
    inc = CosNaming::NamingContext::_narrow(obj);

    // create name to register servant with NameService
    CosNaming::Name n_comp;
    n_comp.length(1);
    n_comp[0].id = "LogServer";
    n_comp[0].kind = "SimpleLogger";

    // register servant with NameService
    inc->rebind(n_comp, servant.in());

    // run orb
    orb->run();
}
