using System;
using System.Runtime.Remoting.Channels;
using Ch.Elca.Iiop;
using Ch.Elca.Iiop.Services;
using omg.org.CosNaming;

namespace Example {
  public class DotNetLoggerImpl
    : MarshalByRefObject, DotNetLogger
  {

    private LogServer logserver;

    public override object InitializeLifetimeService(){
      return null;
    }

    public DotNetLoggerImpl () {
      try {
        string nameServiceHost = "corba.convertic.com";
        int nameServicePort = 50000;

        IiopClientChannel channel =
          new IiopClientChannel();
        ChannelServices.RegisterChannel(channel);

        CorbaInit init = CorbaInit.GetInit();
        NamingContext nameService = init.GetNameService(
          nameServiceHost, nameServicePort);

        NameComponent[] name = new NameComponent[] {
          new NameComponent("LogServer", "SimpleLogger")
        };

        this.logserver =
          (LogServer)nameService.resolve(name);
      } catch (Exception e) {
        Console.WriteLine("exception: " + e);
      }
    }

    public void log(string channel, string message) {
      try {
        this.logserver.log(channel,message);
      } catch (Exception e) {
        Console.WriteLine("exception: " + e);
      }
    }
  }

}
