#!/bin/sh

# cos naming service configuration
START_NAMING_SERVICE=-YES-
NAMING_SERVICE_HOST=`hostname`
NAMING_SERVICE_PORT=50000
NAMING_SERVICE_BIN_PATH=${TAO_ROOT}/orbsvcs/Naming_Service
NAMING_SERVICE=Naming_Service

# environment configuration

# automatic configuration
BASEPATH=`dirname $0`/..
VARDIR=${BASEPATH}/var
PATH=$PATH:${TAO_ROOT}/bin:${NAMING_SERVICE_BIN_PATH}

# export configuration

export PATH

case "$1" in
    start)
        if [ "${START_NAMING_SERVICE:=-NO-}" = "-YES-" ]; then
            echo -n "starting CORBA Naming Service on host "
            echo -n ${NAMING_SERVICE_HOST}
            echo -n " using port "
            echo -n ${NAMING_SERVICE_PORT}
            echo -n " ... "
            $NAMING_SERVICE -ORBEndpoint iiop://${NAMING_SERVICE_HOST}:${NAMING_SERVICE_PORT} &
            if [ ! -d ${VARDIR} ]; then mkdir ${VARDIR};fi
            echo $! > ${VARDIR}/Naming_Service.pid
            sleep 4
            echo "started."
        fi
        ${BASEPATH}/corba/LogServer -ORBInitRef NameService=iiop://${NAMING_SERVICE_HOST}:${NAMING_SERVICE_PORT}/NameService &
        if [ ! -d ${VARDIR} ]; then mkdir ${VARDIR};fi
        echo $! > ${VARDIR}/server.pid
        ;;
    stop)
        if [ -f ${VARDIR}/server.pid ]; then
            kill `cat ${VARDIR}/server.pid`
            rm ${VARDIR}/server.pid
        fi
        if [ "${START_NAMING_SERVICE:=-NO-}" = "-YES-" ]; then
            if [ -f ${VARDIR}/Naming_Service.pid ]; then
                kill `cat ${VARDIR}/Naming_Service.pid`
                rm ${VARDIR}/Naming_Service.pid
            fi
        fi
        ;;
    *)
        echo "usage $0 start|stop"
esac
