package Example;

import java.lang.*;
import java.util.*;

import org.omg.CORBA.*;

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

import javax.ejb.SessionBean;
import javax.ejb.CreateException;

/**
 * @ejb.bean type="Stateless"
 *  name="ejbLogger"
 *  view-type="both"
 *  jndi-name="example/LogServerBean"
 *  local-jndi-name="example/LogServerBeanLocal"
 */
public abstract class LogServerBean implements SessionBean {
    private Example.LogServer logserver;
    private javax.ejb.SessionContext _sessionCtx;
    private boolean initialized = false;


    protected void init() {
        try {
            String[] args = null;
            Properties props = new Properties();
            ORB orb = ORB.init(args, props);
            org.omg.CORBA.Object obj =
                orb.resolve_initial_references("NameService");
            NamingContextExt namingserver = NamingContextExtHelper.narrow(obj);
            this.logserver = Example.LogServerHelper.narrow(
                    namingserver.resolve_str("LogServer.SimpleLogger") );
            if (this.logserver == null) {
                throw new RuntimeException("logserver is null!");
            }
            this.initialized = true;
        } catch (Exception e) {
            throw new RuntimeException("Failed in init()",e);
        }
    }

    /** @ejb.interface-method */
    public void log(String channel, String message) {
        if (!this.initialized) {
            this.init();
        }
        try {
            this.logserver.log(channel ,message);
        } catch (Exception e) {
            throw new RuntimeException("failed in log()",e);
        }
    }

}
